var/list/segments = list()


proc/LoadSegments()
	var/tempstate
	for(var/i in 1 to 8)
		for(var/j in i to 9)
			tempstate = num2text(i) + num2text(j)
			var/obj/egysegment/E = new()
			E.icon_state = tempstate
			segments[tempstate] = E


obj/egysegment
	icon = 'enneaglyphs.dmi'


obj/glyph
	var/constructor


	New()
		. = ..()

		if(constructor)
			Construct(constructor)


	proc/Construct(T)
		var
			curchar; nextchar

		if(!length(segments)) LoadSegments()

		for(var/i in 1 to 8)
			curchar = num2text(findtext(T, num2text(i)))
			nextchar = num2text(findtext(T, num2text(i + 1)))

			if(curchar < nextchar)
				overlays += segments["[curchar][nextchar]"]
			else
				overlays += segments["[nextchar][curchar]"]


//To use enneaglyphs in your own program, remove the part below and construct your own as desired.
turf/background
	//Allows clicking on map to create a custom glyph.
	icon = 'background.dmi'


	Click()
		var/T = input("Enter 9 unique digits (1-9 in any order)")
		var/obj/glyph/G = new(src)
		G.Construct(T)


obj/glyph/sample
	//Sample of how to define a glyph that builds itself when it is instantiated.
	constructor = "789612543"
